//problem3-3-1 (3)


#include<stdio.h>
#include<stdlib.h>
#include<math.h>


#define dx  	0.2		//width


void PDF_normal( double *data , int data_num ,double data_min , int imax , double *output){	//PDF
	int i ;
	
	for( i=0 ; i<data_num ; i++ ){
		output[(int)( ( data[i] - data_min )/dx) ] += 1.0/data_num;
	}
	for( i=0 ; i<imax ; i++){
		output[i] /= dx;
	}
}



int main( int argc , char *argv[] ){
	//input from shell-file
	//argv[1] -> the number of data
	
	int i , tmp;
	int N = atoi(argv[1]);				//the number of data
	double data_min , data_max ;		//the minimum & maximum of data
	int imax;							//the number of box
	
	double *data;						//data
	double *F;							//output : PDF
	data = (double *)calloc( N , sizeof(double) );
	
	
	FILE *fpr , *fpw;
	if( (fpr = fopen("data.dat","r")) == NULL ){
		printf("Error Reading\n");
		exit(1);
	}
	if( (fpw = fopen("problem3_3_1_1.dat","w")) == NULL ){
		printf("Error Writing\n");
		exit(1);
	}
	
	for(i=0 ; i< N ; i++){		//input the data  &  get the maximum and minimum
		fscanf(fpr , "%lf", &data[i]);
		data_max = ( i == 0 || data_max < data[i] )? data[i] : data_max;
		data_min = ( i == 0 || data_min > data[i] )? data[i] : data_min;
	}
	
	imax = (int)( ( data_max - data_min ) / dx ) + 1;		//the number of box tends to min and max
	F = (double * )calloc( imax, sizeof(double));
	
	PDF_normal( data , N , data_min , imax , F);
	
	for(i= 0 ; i < imax ; i++){
		fprintf( fpw , "%.10f	%.10f\n" , data_min +  (i+0.5)* dx  , F[i] );
	}
	
	fclose(fpr);
	fclose(fpw);
	free(data);
	free(F);
	
	return 0;
}
	
		 