#!/bin/bash

##(1)
gcc -o problem3_3_1.exe problem3_3_1.c

#the number of data
line=$(cat data.dat | wc -l )

./problem3_3_1.exe	${line}


gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_1_1.eps"
set size 0.6 , 0.6
set xlabel "Value"
set ylabel "PDF"
set xrange [0:5]
set yrange [0:]
plot	"problem3_3_1_1.dat" noti w boxes
EOF



##(2)
##note : awk -v -> use the shellscript-variable in awk

sort -gr data.dat |\
awk -v line="${line}" '
{
	print $1,NR/line
}
' > problem3_3_1_2.dat



gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_1_2.eps"
set size 0.6 , 0.6
set xlabel "Value"
set ylabel "CDF"
set xrange [1:4]
set yrange [ :1]
plot	"problem3_3_1_2.dat" noti w l
EOF
